# coding=utf-8
import re;

from utils import _
#from tut_data import say

# import construct_call_graph
#

tutorial_vars = {}

class InputError(Exception):
    def __init__(self, msg):
        self.msg = msg

import parser # suite(code)

def ast2code(ast_list, result):
    '''takes ast as list, returns simple list of items in expression
    >>> ast2code( ast2list(suite('print func(a+5)-10')) )
    ['print', 'func', '(', 'a', '+', '5', ')', '-', '10']
    '''
    #print "doing ast2code(%s)" % arg
    if isinstance(ast_list, (list, tuple)):
        for x in ast_list:
            if isinstance(x, (list, tuple)):
                ast2code(x, result)
        endingatom = ast_list[-1]
        if not isinstance(endingatom , (list, tuple)):
            if endingatom:
                result.append( endingatom  )
    return result
			
	
import re
re_slice_expr = re.compile(r'(\w+\b)')		
def find_input_mistake(input, expected, tryinterpret = True):
        
    input = input.strip('> ;')
    expected = expected.strip('> ;')

    expr_list = { 'input' : [], 'expected' : [] }
    if tryinterpret:
        try:
            ast2code( parser.ast2list(parser.suite(input)), expr_list['input'] )
            ast2code( parser.ast2list(parser.suite(expected)), expr_list['expected'] )
        except SyntaxError, e:
            #filename, lineno, offset and text
            print _("You probably made mistake: \n%s \n%s^ \n") % (e.text.split('\n')[e.lineno-1], ' '*(e.offset-1) )
            print str(e)
            return True
    else:
        # should use regexp someday -- if there's easy way to split lexical atoms according to boundaries ;) 
        expr_list['input'] = input
        expr_list['expected'] = expected

    if expr_list['input'] == expr_list['expected']:
        return False
        
        
    for i in range(len(expr_list['input'])): # find the literal place of mistake
        if i >= len(expr_list['expected']):
            print _("You wrote too much stuff")
            return True
                        
        elif expr_list['input'][i] == expr_list['expected'][i]:
                continue
        else:
            input_shift = 0
            list_item_nr = 0
            for x in expr_list['input'][:i+1]:
                #print 'input_shift, input[input_shift:], x:', input_shift, "'"+input[input_shift:]+"'",  "'"+x+"'"
                while input[input_shift] in ' \t\n':
                    input_shift += 1
                    
                if input[input_shift:].startswith(x):
                    input_shift += len(x)
                    list_item_nr += 1
                else:
                    raise Exception('problems when parsing/comparing input with expected')
            input_shift -=  len(expr_list['input'][i])-1
            
            for char_nr, char in  enumerate(expr_list['expected'][i]):
                if char_nr+1 < len(expr_list['input'][i]) \
                and char == expr_list['input'][i][char_nr]:
                    input_shift += 1
                            
            print _("You probably made mistake: \n%s \n%s^ \n") % (input, ' '*(input_shift-1))
            #print say['howto_correct_tip']
            #print "(or you don't want to follow the tutorial ;)"
            return True

    if len(expr_list['input']) < len(expr_list['expected']):
        print _("Your line is missing something")
        return True

        

def process_input(input, result=''):
    
    #validate_input(input)
    process_type = ''
    result_var = ''
    if not result:
        try:
            result = eval(input, tutorial_vars)
            process_type = 'eval'
        except SyntaxError:
            try:
                exec(input) in tutorial_vars
                process_type = 'exec'
            except SyntaxError:
                raise InputError(_("Probably bad input"))
        except NameError:
            pass

        if process_type == 'exec':
            if input.find('=') > input.find('=='):
                result = eval(input[:input.find('=')], tutorial_vars)
                result_var = input[:input.find('=')].strip()
            

            #~ print result
#~ 
    #~ elif process_type == 'eval':
        #~ print result

    #~ print (_("%s result: %s") % (process_type, result)).strip()
    if result:
        print (_("result %s: %s") % (result_var, result)).strip()
    print
